import React from 'react';
import { FieldValues, Options, OnSubmit, ValidationPayload, ElementLike, DefaultFieldValues } from './types';
export default function useForm<FormValues extends FieldValues = DefaultFieldValues, FieldName extends keyof FormValues = keyof FormValues, FieldValue = FormValues[FieldName]>({ mode, validationSchema, defaultValues, validationFields, nativeValidation, submitFocusError, validationSchemaOption, }?: Options<FormValues>): {
    register: {
        <Element_1 extends ElementLike = ElementLike>(validateRule: Partial<{
            required: string | boolean;
            min: string | number | {
                value: string | number;
                message: string;
            };
            max: string | number | {
                value: string | number;
                message: string;
            };
            maxLength: string | number | {
                value: string | number;
                message: string;
            };
            minLength: string | number | {
                value: string | number;
                message: string;
            };
            pattern: RegExp | {
                value: RegExp;
                message: string;
            };
            validate: import("./types").Validate | Record<string, import("./types").Validate> | {
                value: import("./types").Validate | Record<string, import("./types").Validate>;
                message: string;
            };
        }>): (ref: Element_1 | null) => void;
        <Element_2 extends ElementLike = ElementLike>(ref: Element_2 | null, validationOptions?: Partial<{
            required: string | boolean;
            min: string | number | {
                value: string | number;
                message: string;
            };
            max: string | number | {
                value: string | number;
                message: string;
            };
            maxLength: string | number | {
                value: string | number;
                message: string;
            };
            minLength: string | number | {
                value: string | number;
                message: string;
            };
            pattern: RegExp | {
                value: RegExp;
                message: string;
            };
            validate: import("./types").Validate | Record<string, import("./types").Validate> | {
                value: import("./types").Validate | Record<string, import("./types").Validate>;
                message: string;
            };
        }> | undefined): void;
    };
    unregister: {
        (name: string | FieldName): void;
        (names: (string | FieldName)[]): void;
    };
    handleSubmit: (callback: OnSubmit<FormValues>) => (e: React.SyntheticEvent<Element, Event>) => Promise<void>;
    watch: {
        (): FormValues;
        (field: string | FieldName, defaultValue?: string | undefined): FieldValue;
        (fields: (string | FieldName)[], defaultValues?: Partial<FormValues> | undefined): Partial<FormValues>;
    };
    reset: (values?: Record<string, any> | undefined) => void;
    clearError: {
        (): void;
        (name: FieldName): void;
        (names: FieldName[]): void;
    };
    setError: (name: FieldName, type: string, message?: string | undefined, ref?: any) => void;
    setValue: (name: FieldName, value: FieldValue, shouldValidate?: boolean) => void | Promise<boolean>;
    triggerValidation: (payload?: ValidationPayload<FieldName, FieldValue> | ValidationPayload<FieldName, FieldValue>[] | undefined) => Promise<boolean>;
    getValues: (payload?: {
        nest: boolean;
    } | undefined) => FormValues;
    errors: Partial<Record<keyof FormValues, import("./types").FieldError>>;
    formState: {
        isValid: boolean;
        dirty: boolean;
        isSubmitted: boolean;
        submitCount: number;
        touched: FieldName[];
        isSubmitting: boolean;
    };
};
